%define changeset 3ace933
%define subver 0

Name:       teambox
Version:    2.2
Release:    %mkrel 6
Summary:    A project management software with a focus on collaboration
Group:      Networking/WWW
License:    AGPLv3
URL:        http://teambox.com/
Source0:    https://github.com/%{name}/%{name}/tarball/%{name}-%{name}-%{version}-%{subver}-g%{changeset}.tar.gz
Source101:  %{name}.logrotate
Source102:  %{name}.httpd
Source103:  README.urpmi
Patch0:     teambox-2.2-fix-paperclip.patch
Patch1:     teambox-2.2-strip-Gemfile.patch
# core
BuildRequires: rubygem(bundler) >= 1.0.0
BuildRequires: rubygem(rails) >= 2.3.5
BuildRequires: rubygem(text-format) >= 0.6.3
BuildRequires: rubygem(SystemTimer) >= 1.2.0
BuildRequires: rubygem(whenever) >= 0.4.1
BuildRequires: rubygem(icalendar) >= 1.1.3
BuildRequires: rubygem(libxml-ruby) = 1.1.3
BuildRequires: rubygem(rdiscount) >= 1.3.1.1
BuildRequires: rubygem(haml) >= 3.0.0
BuildRequires: rubygem(pg) >= 0.9
BuildRequires: rubygem(mysql) >= 2.8.1
BuildRequires: rubygem(sqlite3) >= 1.2.5
BuildRequires: rubygem(aws-s3) >= 0.6.2
BuildRequires: rubygem(hpricot) >= 0.8.2
BuildRequires: rubygem(json)
BuildRequires: rubygem(oa-oauth)
BuildRequires: rubygem(tilt)
BuildRequires: rubygem(choices) >= 0.2.0
# plugins
BuildRequires: rubygem(sprockets-rails) >= 0.0.1
BuildRequires: rubygem(thinking-sphinx) >= 1.3.15
BuildRequires: rubygem(will_paginate) >= 2.3.14
BuildRequires: rubygem(paperclip) >= 2.3.6
BuildRequires: rubygem(vestal_versions) >= 1.0.2
BuildRequires: rubygem(cancan) >= 1.2.0
BuildRequires: rubygem(ruby-debug) >= 0.10.3
# testing
BuildRequires: mysql
BuildRequires: postgresql-server
BuildRequires: rubygem(cucumber-rails) >= 0.3.0
BuildRequires: rubygem(database_cleaner) >= 0.5.0
BuildRequires: rubygem(factory_girl) >= 1.2.3
BuildRequires: rubygem(launchy) >= 0.3.5
BuildRequires: rubygem(pickle) >= 0.2.1
BuildRequires: rubygem(rcov)
# core
Requires:   webserver
Requires:   imagemagick
Requires:   %{name}-db = %{version}-%{release}
Requires:   rubygem(bundler) >= 1.0.0
Requires:   rubygem(rails) >= 2.3.5
Requires:   rubygem(text-format) >= 0.6.3
Requires:   rubygem(SystemTimer) >= 1.2.0
Requires:   rubygem(whenever) >= 0.4.1
Requires:   rubygem(icalendar) >= 1.1.3
Requires:   rubygem(libxml-ruby) = 1.1.3
Requires:   rubygem(rdiscount) >= 1.3.1.1
Requires:   rubygem(haml) >= 3.0.0
Requires:   rubygem(aws-s3) >= 0.6.2
Requires:   rubygem(hpricot) >= 0.8.2
Requires:   rubygem(json)
Requires:   rubygem(oa-oauth)
Requires:   rubygem(tilt)
Requires:   rubygem(choices) >= 0.2.0
# plugins
Requires:   rubygem(sprockets-rails) >= 0.0.1
Requires:   rubygem(thinking-sphinx) >= 1.3.15
Requires:   rubygem(will_paginate) >= 2.3.14
Requires:   rubygem(paperclip) >= 2.3.6
Requires:   rubygem(vestal_versions) >= 1.0.2
Requires:   rubygem(cancan) >= 1.2.0
Requires:   rubygem(ruby-debug) >= 0.10.3
Requires:   rubygem(validates_email_format_of) >= 1.4.2
Requires:   rubygem(ruby-debug) >= 0.10.3
Suggests:   %{name}-httpd

BuildArch:  noarch

%description
Teambox workflow is project-centered; each project being visible only to people
invited to it.
Projects have a status wall, conversations, tasks, shared pages and file
uploads. You can even post to everywhere just using email.

%files
%defattr(-,root,root,-)
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%doc README.md LICENSE config/database.example.yml
%dir %{_var}/www/%{name}/
%{_var}/www/%{name}/Rakefile
%{_var}/www/%{name}/app/
%dir %{_var}/www/%{name}/config/
%exclude %{_var}/www/%{name}/config/database*.yml
%config(noreplace) %{_var}/www/%{name}/config/*.yml
%{_var}/www/%{name}/config/environments/
%{_var}/www/%{name}/config/initializers/
%{_var}/www/%{name}/config/locales/
%{_var}/www/%{name}/config/*.rb
%{_var}/www/%{name}/db/
%doc %{_var}/www/%{name}/doc/
%{_var}/www/%{name}/features/
%{_var}/www/%{name}/Gemfile
%attr(0755,apache,apache) %{_var}/www/%{name}/Gemfile.lock
%{_var}/www/%{name}/lib/
%attr(0755,apache,apache) %{_var}/www/%{name}/log/
%{_var}/www/%{name}/public/
%{_var}/www/%{name}/script/
%{_var}/www/%{name}/spec/
%{_var}/www/%{name}/test/
%attr(0755,apache,apache) %{_var}/www/%{name}/tmp/
%{_var}/www/%{name}/vendor/
#-------------------------------------------------------------------------------
%package        mysql
Summary:    A project management software built on Ruby on Rails with a focus on collaboration
Group:      Networking/WWW
Requires:   mysql
Requires:   rubygem(mysql) >= 2.8.1
Provides:   %{name}-db = %{version}-%{release}

%description    mysql
Teambox workflow is project-centered; each project being visible only to people
invited to it.
Projects have a status wall, conversations, tasks, shared pages and file
uploads. You can even post to everywhere just using email.

This package contains the needed files to use mysql as teambox's database
backend.

%files          mysql
%defattr(-,root,root,-)
%config(noreplace) %{_var}/www/%{name}/config/database.yml
#-------------------------------------------------------------------------------
%package        pg
Summary:    A project management software built on Ruby on Rails with a focus on collaboration
Group:      Networking/WWW
Requires:   postgresql-server
Requires:   rubygem(pg) >= 0.9
Provides:   %{name}-db = %{version}-%{release}

%description    pg
Teambox workflow is project-centered; each project being visible only to people
invited to it.
Projects have a status wall, conversations, tasks, shared pages and file
uploads. You can even post to everywhere just using email.

This package contains the needed files to use postgresql as teambox's database
backend.

%files          pg
%defattr(-,root,root,-)
#-------------------------------------------------------------------------------
%package        sqlite
Summary:    A project management software built on Ruby on Rails with a focus on collaboration
Group:      Networking/WWW
Requires:   rubygem(sqlite3) >= 1.2.5
Provides:   %{name}-db = %{version}-%{release}

%description    sqlite
Teambox workflow is project-centered; each project being visible only to people
invited to it.
Projects have a status wall, conversations, tasks, shared pages and file
uploads. You can even post to everywhere just using email.

This package contains the needed files to use sqlite as teambox's database
backend.

%files          sqlite
%defattr(-,root,root,-)
#-------------------------------------------------------------------------------
%package        httpd
Summary:    A project management software built on Ruby on Rails with a focus on collaboration
Group:      Networking/WWW
Requires:   %{name} = %{version}-%{release}
Requires:   apache-conf

%description    httpd
Teambox workflow is project-centered; each project being visible only to people
invited to it.
Projects have a status wall, conversations, tasks, shared pages and file
uploads. You can even post to everywhere just using email.

This package contains the needed files to use apache as teambox's webserver.

%files          httpd
%defattr(-,root,root,-)
%config(noreplace) %{_webappconfdir}/%{name}.conf
#-------------------------------------------------------------------------------

%prep
%setup -q -n %{name}-%{name}-%{changeset}
%patch0 -p1
%patch1 -p0
echo > Gemfile.lock
cp %{SOURCE103} .

%build
# Copy database.example.yml as it’s mandatory to run teambox
# add modifications for testing
sed '/teambox2_test/a\
  socket: var/lib/mysql.sock' config/database.example.yml > config/database.yml
rm -f lib/tasks/{rspec,cucumber,rcov}.rake
rm -rf vendor/plugins/rspec-on-rails-matchers

%install
rm -rf %buildroot
install -d %{buildroot}%{_var}/www/%{name}
cp -ax * %{buildroot}%{_var}/www/%{name}
rm -f %{buildroot}%{_var}/www/%{name}/{README.{md,urpmi},LICENSE}

#install logrotate file
install -D -m644 %{SOURCE101} %{buildroot}%{_sysconfdir}/logrotate.d/%{name}

#install sample httpd config
install -D -m644 %{SOURCE102} %{buildroot}%{_webappconfdir}/%{name}.conf

#create directory structure
for rep in cache pids sass-cache sessions sockets ; do
    install -d %{buildroot}%{_var}/www/%{name}/tmp/${rep}
done

%check
# initialize database
mysql_install_db --datadir=$PWD/var/lib/mysql/ --user=$USER
# start an unprivileged instance
/usr/sbin/mysqld --datadir=$PWD/var/lib/mysql \
  --socket $PWD/var/lib/mysql.sock \
  --pid-file $PWD/var/lib/mysqld.pid &
#little timeout
sleep 10
# create the test database and populate it
#bundle exec rake db:create db:schema:load RAILS_ENV=test 
kill `cat $PWD/var/lib/mysqld.pid`

%clean
rm -rf %buildroot



%changelog
* Mon Mar 28 2011 shikamaru <shikamaru> 2.2-6.mga1
+ Revision: 78521
- create tmp directory structure (would be better to make that FHS compliant)
- fix tarball (use the one on github)
- add README.urpmi
  CCBUG: 496

* Fri Mar 25 2011 shikamaru <shikamaru> 2.2-5.mga1
+ Revision: 77188
- add README.urpmi with basic instructions
- add Gemfile.lock
- review Gemfile

* Thu Mar 24 2011 shikamaru <shikamaru> 2.2-4.mga1
+ Revision: 77046
- oops, readd a missing req
- remove unneeded requires
- strip Gemfile
- do not require devel and test gems
- remove database adapters since these are already pulled by subpackages

  + misc <misc>
    - add another missing Requires
    - add missing Requires

* Tue Mar 22 2011 shikamaru <shikamaru> 2.2-2.mga1
+ Revision: 75748
- fix summary too long
- add missing group for main package
- do not remove Gemfile

* Fri Mar 04 2011 shikamaru <shikamaru> 2.2-1.mga1
+ Revision: 64363
- Improve database handling
- require teambox-db
- add subpackages for mysql/postgres/sqlite
- fix BR
- move %%files on top to improve spec readability
- temporarily remove capybara
- Fix errors and add some helpers
- logrotate script
- httpd conf in a suggested subpackage
- kill buildroot
- buildarch should be noarch
- prevent config files to be overriden
- imported package teambox

